#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Diagram;

namespace Syncfusion.Windows.Forms.Diagram.Samples.DynamicSymbol
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram;
		private System.Windows.Forms.ImageList imageList;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemInsertSymbol;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Register an InsertSymbolTool with the controller for inserting MySymbol objects.
			//
			this.diagram.Controller.RegisterTool(new InsertSymbolTool("InsertMySymbol", typeof(HostSymbol)));

			// Register a custom tool that draws a Rectangle shape with a Bitmap image within it
			CustomRectTool recttool = new CustomRectTool("CustomRectangleTool");
			recttool.DisplayImage = new Bitmap("..\\..\\..\\911_WP.bmp");
			this.diagram.Controller.RegisterTool(recttool);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.diagram = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.imageList = new System.Windows.Forms.ImageList(this.components);
			this.mainFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "Edit");
			this.barItemInsertSymbol = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).BeginInit();
			this.SuspendLayout();
			// 
			// diagram
			// 
			this.diagram.AllowDrop = true;
			// 
			// diagram.Controller
			// 
			this.diagram.Controller.MaxHistory = 256;
			this.diagram.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram.HScroll = true;
			this.diagram.LayoutManager = null;
			this.diagram.Location = new System.Drawing.Point(0, 26);
			// 
			// diagram.Model
			// 
			this.diagram.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.GradientAngle = 90F;
			this.diagram.Model.BackgroundStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram.Model.BackgroundStyle.GradientBounds")));
			this.diagram.Model.BackgroundStyle.GradientStartColor = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.Properties = this.diagram.Model;
			this.diagram.Model.BackgroundStyle.Texture = null;
			this.diagram.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.BackgroundStyle.BackgroundType.Solid;
			this.diagram.Model.BoundaryConstraintsEnabled = true;
			this.diagram.Model.FillStyle.AlphaFactor = 255;
			this.diagram.Model.FillStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.FillStyle.GradientAngle = 90F;
			this.diagram.Model.FillStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram.Model.FillStyle.GradientBounds")));
			this.diagram.Model.FillStyle.GradientStartColor = System.Drawing.Color.LightGray;
			this.diagram.Model.FillStyle.Properties = this.diagram.Model;
			this.diagram.Model.FillStyle.Texture = null;
			this.diagram.Model.FillStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram.Model.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyle.FillType.Solid;
			this.diagram.Model.Height = 5000F;
			this.diagram.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.diagram.Model.LineStyle.DashOffset = 0F;
			this.diagram.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.diagram.Model.LineStyle.EndCap = System.Drawing.Drawing2D.LineCap.Flat;
			this.diagram.Model.LineStyle.LineColor = System.Drawing.Color.Black;
			this.diagram.Model.LineStyle.LineJoin = System.Drawing.Drawing2D.LineJoin.Bevel;
			this.diagram.Model.LineStyle.LineWidth = 2F;
			this.diagram.Model.LineStyle.MiterLimit = 10F;
			this.diagram.Model.LineStyle.Properties = this.diagram.Model;
			this.diagram.Model.MeasurementScale = 1F;
			this.diagram.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Pixel;
			this.diagram.Model.Name = "Model";
			this.diagram.Model.RenderingStyle.Properties = this.diagram.Model;
			this.diagram.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.Default;
			this.diagram.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.ShadowStyle.OffsetX = 6F;
			this.diagram.Model.ShadowStyle.OffsetY = 6F;
			this.diagram.Model.ShadowStyle.Properties = this.diagram.Model;
			this.diagram.Model.ShadowStyle.Visible = false;
			this.diagram.Model.Width = 5000F;
			this.diagram.Model.PropertyChanged += new Syncfusion.Windows.Forms.Diagram.PropertyEventHandler(this.diagram_Model_PropertyChanged);
			this.diagram.Name = "diagram";
			this.diagram.NudgeIncrement = 1F;
			this.diagram.ScrollGranularity = 0.5F;
			this.diagram.Size = new System.Drawing.Size(536, 380);
			this.diagram.TabIndex = 0;
			this.diagram.Text = "diagram1";
			// 
			// diagram.View
			// 
			this.diagram.View.BackgroundColor = System.Drawing.Color.DarkGray;
			this.diagram.View.Grid.Color = System.Drawing.Color.Black;
			this.diagram.View.Grid.DashOffset = 4F;
			this.diagram.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			this.diagram.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Point;
			this.diagram.View.Grid.HorizontalSpacing = 10F;
			this.diagram.View.Grid.SnapToGrid = true;
			this.diagram.View.Grid.VerticalSpacing = 10F;
			this.diagram.View.Grid.Visible = true;
			this.diagram.View.HandleAnchorColor = System.Drawing.Color.LightGray;
			this.diagram.View.HandleColor = System.Drawing.Color.White;
			this.diagram.View.HandleDisabledColor = System.Drawing.Color.Black;
			this.diagram.View.HandleSize = 6;
			this.diagram.View.HorizontalRuler.Visible = false;
			this.diagram.View.MouseTrackingEnabled = true;
			this.diagram.View.PasteOffsetX = 10;
			this.diagram.View.PasteOffsetY = 10;
			this.diagram.View.RulerFillColor = System.Drawing.Color.LightGray;
			this.diagram.View.RulerLineColor = System.Drawing.Color.Black;
			this.diagram.View.RulerSize = 16;
			this.diagram.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Inches;
			this.diagram.View.ShowPageBounds = true;
			this.diagram.View.VerticalRuler.Visible = false;
			this.diagram.VScroll = true;
			// 
			// imageList
			// 
			this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList.ImageStream")));
			this.imageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// mainFrameBarManager
			// 
			this.mainFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("mainFrameBarManager.BarPositionInfo")));
			this.mainFrameBarManager.Bars.Add(this.bar1);
			this.mainFrameBarManager.Categories.Add("Edit");
			this.mainFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.mainFrameBarManager.Form = this;
			this.mainFrameBarManager.ImageList = this.imageList;
			this.mainFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											 this.barItemInsertSymbol,
																											 this.barItem1});
			this.mainFrameBarManager.LargeImageList = null;
			this.mainFrameBarManager.ResetCustomization = false;
			// 
			// bar1
			// 
			this.bar1.BarName = "Edit";
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItemInsertSymbol,
																							  this.barItem1});
			this.bar1.Manager = this.mainFrameBarManager;
			// 
			// barItemInsertSymbol
			// 
			this.barItemInsertSymbol.CategoryIndex = 0;
			this.barItemInsertSymbol.ID = "InsertSymbol";
			this.barItemInsertSymbol.ImageIndex = 0;
			this.barItemInsertSymbol.Text = "InsertSymbol";
			this.barItemInsertSymbol.Click += new System.EventHandler(this.barItemInsertSymbol_Click);
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 0;
			this.barItem1.ID = "CustomRectTool";
			this.barItem1.ImageIndex = 1;
			this.barItem1.Text = "Custom Rectangle Tool";
			this.barItem1.Click += new System.EventHandler(this.barItem1_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 406);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.diagram});
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Dynamic Symbol";
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void barItemInsertSymbol_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("InsertMySymbol");
		}

		private void diagram_Model_PropertyChanged(object sender, Syncfusion.Windows.Forms.Diagram.PropertyEventArgs evtArgs)
		{
			this.diagram.View.Update();
		}

		// Create the custom Rectangle Tool with the Bitmap and activate it
		private void barItem1_Click(object sender, System.EventArgs e)
		{
			//CustomRectTool recttool = new CustomRectTool();
			//recttool.DisplayImage = new Bitmap("..\\..\\..\\911_WP.bmp");
			CustomRectTool recttool = this.diagram.Controller.GetTool("CustomRectangleTool") as CustomRectTool;
			//ustomRectTool rec
			this.diagram.Controller.ActivateTool(recttool);
		}
	}
}
